/***********************************************************
  Common Utility functions
***********************************************************/
// Here we translate from codee to string and viceversa
function lookUp( matrix, value )
{
  trace("lookUp( [" + matrix + "], " + value +"); matrix.length: " + matrix.length);
  if (isNaN(parseInt(value)))
  {
    for (i=0; i<matrix.length; ++i)
      if (matrix[i][1].toUpperCase() == value.toUpperCase())
        return matrix[i][0];
  }
  else
  {
    for (i=0; i<matrix.length; ++i)
      if (matrix[i][0] == value)
        return matrix[i][1];
  }
}

// Looks for a value in an array and return the position it's stored in or -1 otherwise
function find(matrix, value, position)
{
  nRet = -1;
  if (position < 0)
    position = 0;
  for (i = position; i < matrix.length; ++i)
  {
    trace("Matrix[" + i + "]= " + matrix[i]);
    if (matrix[i] == value) return i;
  }
  return nRet;
}

// Port Configuration
function getPortConfiguration()
{
	var filename = System.getProjectDir() + "\\config.txt"
	
	// Load the file
	var theFile = new File(filename);
	if (theFile.exists)
	{
		theFile.open(File.ReadOnly);
		var theString = theFile.readLine();
		theFile.close();
		
		var theArgs = 	theString.split(",");
		strComPort  = theArgs[0];
		strBaudRate = theArgs[1];
		strDataBits   = theArgs[2];
		strParity       = theArgs[3];
		strStopBits   = theArgs[4];
		strFlowControl = theArgs[5];
	}
	else
	{
		strComPort  = "COM2";
		strBaudRate = "B 38400";
		strDataBits   = "b 8";
		strParity       = "None";
		strStopBits   = "b 1";
		strFlowControl = "Off";
	}
}

function setPortConfiguration()
{
    trace("-> Save Default Configuraion ");
		
	var filename = System.getProjectDir() + "\\config.txt"
	
	// Load the file
	var theFile = new File(filename);
   theFile.open(File.WriteOnly);
   var theArgs = new Array( strComPort, strBaudRate, strDataBits, strParity, strStopBits, strFlowControl, ""  );  	
	theFile.writeLine(theArgs.join());
	theFile.close();
}

function getComPort()
{
  return strComPort;
}

function setComPort(comPort)
{
  strComPort = comPort;
}

function getBaudRate()
{
  return strBaudRate;
}

function setBaudRate(baudRate)
{
  strBaudRate = baudRate;
}

function getDataBits()
{
  return strDataBits;
}

function setDataBits(dataBits)
{
  strDataBits = dataBits;
}

function getParity()
{
  return strParity;
}

function setParity(parity)
{
  strParity = parity;
}

function getStopBits()
{
  return strStopBits;
}

function setStopBits(stopBits)
{
  strStopBits = stopBits;
}

function getFlowControl()
{
  return strFlowControl;
}

function setFlowControl(flowControl)
{
  strFlowControl = flowControl;
}

// Converts a string into a byte array
function string2Array(str)
{
  var aRet = [];
  for (i=0;i<str.length;++i)
    aRet = aRet.concat(str.charCodeAt(i));
  return aRet;
}

function trace(message)
{
  if (TRACE)
    print(message);
}

function arrayOfIntToString (arrayMex) {
    var str='';
    for(var i=0;i<arrayMex.length;i++) {
	str+=String.fromCharCode(arrayMex[i]);
    }
    return str;
}